#!/system/bin/busybox sh

#############################################################################
# Wive-NG project (wive-ng-sf.net). GPL v3 or later
# This is system managment script fot digma idxd amlogic based devices
#############################################################################

BUSYBOX="/system/bin/busybox"
PREVENT_SYS_CHANGE="y"

# prevent segfault by some android apps
export LD_LIBRARY_PATH=/system/lib

preinstall_system()
{
	echo "Start system preinstall apps..."

	# install apps form internal
	if [ -d /system/preinstall ]; then
	    SYS_LIST=`ls /system/preinstall | grep "\.apk$"`
	    for pkt in $SYS_LIST
	    do
			 mv /system/preinstall/$pkt /system/app/
			 chmod 644 /system/app/$pkt
			 chown 0:0 /system/app/$pkt
	    done
	fi
	echo "End system preinstall apps..."
}

preinstall()
{
    (
	echo "Start preinstall apps..."

	# install apps form sdcard
	if [ -d /sdcard1/preinstall ]; then
	    SDE_LIST=`ls /sdcard1/preinstall | grep "\.apk$"`
	    for pkt in $SDE_LIST
	    do
			/system/bin/sh /system/bin/pm install /sdcard1/preinstall/$pkt
    	 done
   fi

	echo "End preinstall apps..."
    ) &
}

backup()
{
    mkdir -p /sdcard1/preinstall
    cp -f /data/app/*.apk /sdcard1/preinstall/
    sync
}

if [ "$1" = "batcalib" ]; then
    echo b820 > /sys/devices/i2c-2/2-0034/axp20_reg
    echo 0800 > /sys/devices/i2c-2/2-0034/axp20_reg
    echo -n > /data/system/batterystats.bin
    echo -n > /data/.battery-calibrated
    echo "Reboot system after drop axp counters"
    sync
    sleep 5
    reboot
fi

clearcache()
{
    rm -rf /cache/*
    rm -rf /data/dalvik-cache/*
    echo "Reboot system after drop system caches"
    sync
    sleep 5
    reboot
}

#######################################################################

if [ "$1" = "preinstall" ]; then
    preinstall
fi

if [ "$1" = "backup" ]; then
    backup
fi


if [ "$1" = "clearcache" ]; then
	clearcache
fi

#######################################################################

if [ ! -e /system/.notfirstrun ]; then
    echo "prepare system"    
    mount /system -o remount,rw

    preinstall_system

    # set RO to sysytem propertys file
    chmod 444 /system/build.prop
    
    # legacy ril fix
    chmod 755 /system/etc/init-pppd.sh

    # fix permissions for managment tools
    SUID_LIST="toolbox wl pm"
    for binary in $SUID_LIST
    do
		if [ -f "/system/bin/$binary" ]; then
	   	chown 0:0 "/system/bin/$binary"
	  		chmod 6555 "/system/bin/$binary"
		fi
    done
    
    # su root
	 chown 0:0 /system/xbin/su
	 chmod 6755 /system/xbin/su	

    # prevent modify (immutable) for base system binary (safe for stupid apps replaces system files)
    if [ "$PREVENT_SYS_CHANGE" = "y" ]; then
        chattr +i /system/bin/*
        chattr +i /system/lib/*.so
        # only scripts may be change
        chattr -i /system/bin/*.sh
    fi

    if [ ! -f /system/lib/modules.dep ]; then
		depmod
    fi

	 touch /system/.notfirstrun
    sync
    mount /system -o remount,ro

	 # hack on launcher replace
    # killall zygote
fi

if [ ! -e /data/.notfirstrun ]; then

	 # create some dirs
    mkdir -p /data/anr
    mkdir -p /data/system
    mkdir -p /data/misc
    mkdir -p /data/misc/wifi

    # recreate some system configs    
    echo -n > /data/cal.bin
    echo -n > /data/system/batterystats.bin
    echo -n > /data/.battery-calibrated
    echo -n > /data/misc/wifi/ipconfig.txt
    echo -n > /data/anr/traces.txt
    chmod 666 /data/cal.bin
    chmod 666 /data/system/batterystats.bin
    chmod 666 /data/.battery-calibrated
    chmod 666 /data/misc/wifi/ipconfig.txt
    chmod 666 /data/anr/traces.txt
    
    # wait mounts
    sleep 10
    
    # preinstall apps
    preinstall
    touch /data/.notfirstrun
    sync
fi

# always exit with status 0
exit 0
